
#define Version "190312"
// Attention ici
//#define FOSC_INTERNE
#define PROCESSOR "18F26K22"
#define Directory "C:\_MikroC\_MesProjets_MikroC\_18F26K22_46K22"
#define Source "PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_"
#define Projet "18F26K22_Test_lib_LCD_I2C1_Uart1_PCF8754_Inp.mcppi"
#define Power_Supply "5V"
#define FOSC1 "32MHz"
#define FOSC2 "Q8MHzx4"
#define EEPROM "18F26K22_Test_lib_LCD_I2C1_Uart1_PCF8754_Inp_EEPROM.ihex"
#ifdef FOSC_INTERNE
#define Config "PIC18F26k22_FOSC_interne_32MHZ.cfgsch"
#else
#define Config "P18F26K22_FOSC_Q8x4_32Mhz.cfgsch"
#endif

//     ac:pinout

/*
 PCF8574P-2  8 bits PORT I2C   DIP16
 Adresse   @= 40 + adresse<<1 => @ = 0x42
 1  A0=1
 2  A1=0
 3  A2=0
 4  P0
 5  P1
 6  P2
 7  P3
 8 VSS   GND
 9  P4
 10 P5
 11 P6
 12 P7
 13 /INT
 14 SCL I2C
 15 SDA I2C
 16 + VDD

*/

/*
  11/03/2019
 https://forum.mikroe.com/viewtopic.php?f=88&t=74331
   Post subject: I2C read problem

*/


#define BAUD 19200  // UART1
#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Beep 7
#define Separator 0x20   // space
#define ON 1
#define OFF 0

// **********  Config Hardware **********************
#define LCD_ADDR 0x4E     // PCF8574-1 on pigboard YwRobot back located  on LCD4x20
// PCF8574 I2C LCD Port Definition
// P7,P6,P5,P4 = Data, P3=Backlight (BL), P2=E, P1=RW, P0=RS

#define With_PCF8574
#define  PCF8574_ADDR  0x42      //b'01000010' A0=1 A1=0 A2=0


#define LCD_BL 0x08
#define LCD_EN 0x04
#define LCD_RW 0x02
#define LCD_RS 0x01

// ref : ODT OCM-20416D-A2023 LCD Module  8/4/1999
// LCD Command
#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08
#define LCD_LINE1 0x80      // 0x00 + bit D7=1
#define LCD_LINE2 0xC0      // 0x40 + bit D7=1
#define LCD_LINE3 0x94      // 0x14 + bit D7=1
#define LCD_LINE4 0xD4      // 0x54 + bit D7=1



const char chaine0[]=" Directory: "Directory"\r\n";
const char chaine1[]=" Projet : "Projet "\r\n";
const char chaine2[]=" Alim. = "Power_Supply"\r\n";
const char chaine3[]=" Config : "Config"\r\n";
#ifdef FOSC_INTERNE
const char chaine4[]=" FOSC interne "FOSC1"\r\n";
#else
const char chaine4[]=" FOSC Quartz= "FOSC2"\r\n";
#endif
const char chaine5[]=" Port Hard UART1 19200,N,8,1 (RC6=TX RC7=RX) \r\n";
const char chaine6[]=" LCD 4x20 sur PCF8574-1 \r\n";
const char chaine7[]=" Init RA0=EA0=LM35DZ\r\n";
const char chaine8[]=" Source "Source"_"Version".c\r\n" ;
const char chaine9[]=" Test PCF8754-2 en Sorties \r\n";
const char chaine10[]=" Test PCF8754-2 en Entrees \r\n";
const unsigned char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5 ,chaine6,chaine7,chaine8,chaine9,chaine10};
const code char mesg0[]="                   ";

sbit Led_Rouge at LATA4_bit;
sbit Led_Rouge_Dir at TRISA.B4;

unsigned  char TEXTE[80]; // needed also by pointer txt !
unsigned char * txt;
unsigned char CRam1[40];
int i,j,k,l;
int Etat;
unsigned int addr;
float f1;
unsigned char cx=0;
char Presence_Device[8];



#include "built_in.h"     // for  Hi  Lo ..etc
#include "lib_lcd_i2c.h"  //// 18 aout  usage new Library  LCD_I2C

extern unsigned char I2C_PCF8574_Write(unsigned char  Adr,unsigned char value);
extern  void LCD_init_4x20(void);
extern void LCD_putcmd(unsigned char d,unsigned char cmdtype);
extern void LCD_putch(unsigned char d);
extern void LCD_puts(char *s);
extern void LCD_putsRom(code char *s);
extern void LCD_Msg_Status(const char* T);  // affiche un TEXTE en ligne 4
extern void LCD_Write_CText(const char *txt) ;
extern void LCDHandler(char c);

void strConstRamCpy(unsigned char *dest, const code char *source);
void Init_Hardware(void) ;
void CRLF1(void);
void UART1_Write_CText(const char *txt);

char check_device(unsigned int dev_address);
void Ecriture_PCF8574(short int k) ;
unsigned char Lecture_PCF8574(void);


// * --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void Binarise (unsigned char k)
{
 int i,j  ;
 j=128;
 for (i=0; i<8;i++)
 {
   if ((k & j)==j)
   {
     UART1_Write('1');
     k=k-j;
   }
   else
   UART1_Write('0');
   j=j>>1;
 }
}

void Ecriture_PCF8574(short int k)
 {
  char S,dummy;
  I2C1_Start();
  S=I2C1_Wr(PCF8574_ADDR);
  if(S == 0)        //check if bus collision happened
  {
    dummy = SSPBUF;        //upon bus collision detection clear the buffer,
    SSPCON1.WCOL=0;    // clear the bus collision Etat bit
  }
 S= I2C1_Wr(k);
 I2C1_Stop();
}
 
 void Init_Hardware()
{
  PORTB = 0xFF;
  TRISB = 0x83;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;
  INTCON2.RBPU=0;  // enable All pull up
  WPUB=0xFF;       // any pin pull up
  CM1CON0=0;
  CM2CON0=0;

  PORTA = 0;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  TRISA = 0b00001111 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3,4,5=Digital output
  PORTA=0;
  Led_Rouge_Dir=0;
  Led_Rouge=OFF;
  
  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC = 0xFF;    //
  // CM1CON0=0;       // disable comparators

  TRISC.TRISC3 = 0;  // SCL I2C
  TRISC.TRISC4 = 1;  // SDA I2C
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  

  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }

 void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

 char  check_device(unsigned int dev_address)
{
 char dum;
 dum=0;
 I2C1_Start();
 if (I2C1_Wr(dev_address))
 {
  sprintf(txt,"Device at adresse %02X  is not found",dev_address);
   UART1_Write_Text(txt);
 }
 else
 {
  sprintf(txt,"Device at adresse %02X \t\t found OK",dev_address);
   UART1_Write_Text(txt);
   dum=1;
  }
I2C1_Stop();
 CRLF1();
 return dum;
}

unsigned char Lecture_PCF8574(void)
{ unsigned char cc;
 char S,dummy;
   I2C1_Start();
   S=I2C1_Wr(PCF8574_ADDR+1);        // send port expander address  A2=0 , A1=0, A=0  , R/W=1
   if(S == 0)        //check if bus collision happened
  {
    dummy = SSPBUF;        //upon bus collision detection clear the buffer,
    SSPCON1.WCOL=0;    // clear the bus collision Etat bit
  }
   cc=I2C1_Rd(0);
   I2C1_Stop();
   return cc;
  }



void main()
 {
 
 #ifdef FOSC_INTERNE
  //OSCTUNE=0;
  // OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur  16Mhz
  //  OSCTUNE.PLLEN=0    ;
  // OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur  8Mhz
  // OSCTUNE.PLLEN=0    ;
  // 8MHz  x4 => 32MHz
  OSCTUNE=0;
  OSCCON = 0b01100000  ; //0x60 ;     //Oscillateur  8Mhz si usage PLL
  OSCTUNE.PLLEN=1    ;   // 1= avec PLL => 32Mhz    0 =sans PLL => 8Mhz
  OSCCON2=0;
  while (OSCCON.HFIOFS==0); // wait stable oscillator
   #else
   // Q=8Mhz  x PLL
   #endif

  Init_Hardware() ;
  Led_Rouge=ON;

  txt=&TEXTE[0];
  UART1_Init(19200);  // Initalize USART (38400,8,N,1)
  Delay_ms(100);
  UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
  CRLF1();
  Delay_ms(500);
  j=0;
  l=0;
  txt=&TEXTE[0];
  // presentation
  for (i=0;i<11;i++)
  {
    UART1_Write_CText(RS_Str[i]);
    Delay_ms(100);
    }
  Led_Rouge=OFF;
  UART1_Write_CText("\r\n Init LCD I2C1 Hardware at 400Khz\r\n");
  I2C1_Init(400000);
  for (i=0;i<8;i++) Presence_Device[i]=0;
  UART1_Write_CText(" Test Presence LCD 4x20 PCF8574-1 :  ");
  addr=LCD_ADDR;   // 4E   A0=1 A1=1 A2=1
  Presence_Device[0]=check_device(addr)  ;

  UART1_Write_CText(" Test Presence PCF8574-2  :  ");
  addr=PCF8574_ADDR;   // 4E   A0=1 A1=1 A2=1
  Presence_Device[1]=check_device(addr)  ;
  CRLF1();
  UART1_Write_CText("\r\nLCD Init \r\n");

  LCD_init_4x20();   Delay_ms(25);
  
  // *** Main loop ***

  LCD_putcmd(LCD_CLEAR,1);  Delay_ms(25); // LCD Clear
  LCD_putcmd(LCD_LINE1,1);  Delay_ms(25);  // sans ce delai ,les 3 premiers caracteres sont bouffes sur le LCD
  LCD_putsRom((const code unsigned char *)"18F26k22 32MHz MC   ");
  LCD_putcmd(LCD_LINE2,1); Delay_ms(25);
  LCD_putsRom((const code unsigned char *)"Test library LCD I2C");
  LCD_putcmd(LCD_LINE3,1); Delay_ms(25);
  LCD_putsRom((const code unsigned char *)"Mesure Num :        ");
  LCD_putcmd(LCD_LINE4,1); Delay_ms(25);
  LCD_putsRom((const code unsigned char *)"Vitesse Now=        ");
  Delay_ms(500);
  j=0;
  
  // test ecriture
  j=255;
   for (i=0;i<8;i++)
   {
   
   j=1<<i;
    UART1_Write_CText("Ecriture PCF8574_2  " );
    Ecriture_PCF8574(0x00FF-j);     // leds tires au +5V => 0xFF=Eteintes
    ByteToHex(j,CRam1);
    UART1_Write_Text(CRam1);UART1_Write(TAB); Binarise (j); CRLF1();
    Delay_ms(200);
   }
   CRLF1();CRLF1();

   do
   {
   LCD_putcmd(LCD_LINE3+14,1); Delay_ms(25);
   WordToStr(j,CRam1);
   LCD_puts(CRam1);
   f1= (float) j * 3.14159;
   LCD_putcmd(LCD_LINE4+14,1); Delay_ms(25);
   sprintf(txt, "%5.2f",f1);
   LCD_puts(txt);

   // echo sur UART
    UART1_Write_CText("Vitesse Now:  ");
    UART1_Write_Text(CRam1);UART1_Write(TAB);
    UART1_Write_Text(txt); UART1_Write(TAB);

    if (Presence_Device[1]>0)
    {
     cx=Lecture_PCF8574();
     UART1_Write_CText("Lecture PCF8574_2 : " );
     ByteToHex(cx,CRam1);
    UART1_Write_Text(CRam1);UART1_Write(TAB);
    Binarise (cx);   UART1_Write(TAB);
    }
    
    CRLF1();
   j++;
   j=j& 0x00FF;
   Delay_ms(500);
   Led_Rouge=!Led_Rouge;

    }
  while(1);
 }


/*

   Directory: C:_MikroC_MesProjets_MikroC_18F26K22_46K22
 Projet : 18F26K22_Test_lib_LCD_I2C1_Uart1_PCF8754_Inp.mcppi
 Alim. = 5V
 Config : P18F26K22_FOSC_Q8x4_32Mhz.cfgsch
 FOSC Quartz= Q8MHzx4
 Port Hard UART1 19200,N,8,1 (RC6=TX RC7=RX)
 LCD 4x20 sur PCF8574-1
 Init RA0=EA0=LM35DZ
 Source PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input__190312.c
 Test PCF8754-2 en Sorties
 Test PCF8754-2 en Entrees

 Init LCD I2C1 Hardware at 400Khz
 Test Presence LCD 4x20 PCF8574-1 :  Device at adresse 4E                found OK
 Test Presence PCF8574-2  :  Device at adresse 42  is not found


LCD Init
Ecriture PCF8574_2  01  00000001
Ecriture PCF8574_2  02  00000010
Ecriture PCF8574_2  04  00000100
Ecriture PCF8574_2  08  00001000
Ecriture PCF8574_2  10  00010000
Ecriture PCF8574_2  20  00100000
Ecriture PCF8574_2  40  01000000


0 1 mikroCPIC1618.exe -MSF -DBG -pP18F26K22 -RA -C -DL -O11111114 -fo32 -EH"^C
C:\_MikroC\_MesProjets_MikroC\_18F26K22_46K22\18F26K22_Test_lib_LCD_I2C1_Uart1_PCF8754_Inp_EEPROM.ihex" -N"^C
C:\_MikroC\_MesProjets_MikroC\_18F26K22_46K22\18F26K22_Test_lib_LCD_I2C1_Uart1_PCF8754_Inp.mcppi" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\_18F26K22_46K22\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -IP"^C
C:\_MikroC\_MesProjets_MikroC\_18F26K22_46K22\" "PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_190312.c" "
_Lib_Math.mcl" "
_Lib_MathDouble.mcl" "
_Lib_System.mcl" "
_Lib_Delays.mcl" "
_Lib_CType.mcl" "
_Lib_CString.mcl" "
_Lib_CStdlib.mcl" "
_Lib_CMath.mcl" "
_Lib_Conversions.mcl" "
_Lib_Sprintf.mcl" "
_Lib_PrintOut.mcl" "
_Lib_ADC_K22_B.mcl" "
_Lib_EEPROM_1024.mcl" "
_Lib_I2C_c34b12.mcl" "
_Lib_UART_c67b67.mcl"
0 1139 Available RAM: 3875 [bytes], Available ROM: 65536 [bytes]
0 122 Compilation Started P18F26K22.c
2623 123 Compiled Successfully P18F26K22.c
0 122 Compilation Started
_Lib_Delays.c
172 123 Compiled Successfully
_Lib_Delays.c
5 1354  warning: The macro is redefined     #define PROCESSOR 18F46K22     from C:/_MikroC/_MesProjets_MikroC/_18F26K22_46K22/PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_190312.c: 120:    #include "lib_lcd_i2c.h"     previously macro "PROCESSOR" defined as: #define PROCESSOR  "18F26K22"  ^C
C:\_mikroc\_mesprojets_mikroc\_18f26k22_46k22\lib_lcd_i2c.h
0 122 Compilation Started PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_190312.c
37 1504 Initialization of extern object 'mesg0' lib_lcd_i2c.h
370 123 Compiled Successfully PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_190312.c
69 1164 Variable 'dummy' has been eliminated by optimizer PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_190312.c
168 1164 Variable 'S' has been eliminated by optimizer PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_190312.c
168 1164 Variable 'dummy' has been eliminated by optimizer PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_190312.c
245 1164 Variable 'S' has been eliminated by optimizer PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_190312.c
245 1164 Variable 'dummy' has been eliminated by optimizer PIC18F26K22_Test_Lib_LCD_PCF8574_I2C1_et_PCF8754_Input_190312.c
0 127 All files Compiled in 94 ms
0 1144 Used RAM (bytes): 300 (8%)  Free RAM (bytes): 3575 (92%) Used RAM (bytes): 300 (8%)  Free RAM (bytes): 3575 (92%)
0 1144 Used ROM (bytes): 20302 (31%)  Free ROM (bytes): 45234 (69%) Used ROM (bytes): 20302 (31%)  Free ROM (bytes): 45234 (69%)
0 125 Project Linked Successfully 18F26K22_Test_lib_LCD_I2C1_Uart1_PCF8754_Inp.mcppi
0 128 Linked in 78 ms
0 129 Project '18F26K22_Test_lib_LCD_I2C1_Uart1_PCF8754_Inp.mcppi' completed: 375 ms
0 103 Finished successfully: 12 mars 2019, 19:04:17 18F26K22_Test_lib_LCD_I2C1_Uart1_PCF8754_Inp.mcppi


*/